#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <gtk/gtk.h>
#include <pthread.h>
#include <sys/signal.h>

#define versionString "2.0.0.spinlite.0"

extern char **environ;
GtkWidget *lalbum, *lartist, *lsong, *lchannel, *lmenu;
pid_t trpid;
GList *ids, *channels;
int channelID;
pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

int my_system(char *command) 
{
	int pid, status;

	if (command == 0) return 1;
	pid = fork();
	if (pid == -1) return -1;
	if (pid == 0) 
	{
		char *argv[4];
		argv[0] = "sh";
		argv[1] = "-c";
		argv[2] = command;
		argv[3] = 0;
		execve("/bin/sh", argv, environ);
		exit(127);
	}
	trpid = pid;
	do 
	{
		if (waitpid(pid, &status, 0) == -1) 
		{
			trpid = 0;
			if (errno != EINTR) return -1;
		} 
		else 
		{
			trpid = 0;
			return status;
		}
	} 
	while(1);
}

void finish(char *s)
{
	char *t = s, *r =  NULL;
	while ((t = strstr(t, "&amp;")))
	{
		r = strdup(t+5);
		strcpy(t+1, r);
		free(r);
	}
	t = s;
	while ((t = strstr(t, "&quot;")))
	{
		r = strdup(t+6);
		*t = '"';
		strcpy(t+1, r);
		free(r);
	}
	s = realloc(s, strlen(s)+1);
}

void lynx_spinner()
{
	my_system("lynx -source \"http://spinner.com/sp-lite/spinner.jhtml\" > "
			"$HOME/.gspinner.spinner");
}

void lynx_floor(char *sessionID, int BottomSequence, int id)
{
	char buf[256];
	snprintf(buf, 255, "lynx -source \"http://spinner.com/user.dyn;$session"
			"id$%s?command=setcurrentchannel&page=/sp-lite/floor.jh"
			"tml&cmd%d=dummy&version=%s&time=%d&id=%d\" > $HOME/.gs"
			"pinner.floor", sessionID, BottomSequence, 
			versionString, (int)time(NULL), id);
	system(buf);
}

void lynx_roof(char *sessionID)
{
	char buf[256];
	snprintf(buf, 255, "lynx -source \"http://spinner.com/sp-lite/roof.jhtm"
			"l;$sessionid$%s?version=%s\" > $HOME/.gspinner.roof", 
			sessionID, versionString);
	system(buf);
}

char *get_sessionID()
{
	FILE *gsf;
	char buf[256];
	char *sessionID = NULL;
	/* get main page */
	lynx_spinner();
	snprintf(buf, 255, "%s/.gspinner.spinner", getenv("HOME"));
	gsf = fopen(buf, "r");
	if (gsf)
	{
		/* something should be done to check bounds here */
		sessionID = malloc(24);
		memset(sessionID, 0, 24);
		while (fgets(buf, 255, gsf))
		{
			sscanf(buf, "\topencontentwindow(\"/profile/_main.jhtml"
					";$sessionid$%23c\");\r\n" , sessionID);
			if (*sessionID) return sessionID;
		}
	}
	my_system("rm $HOME/.gspinner.spinner");
	return NULL;
}

void get_channels(char *sessionID)
{
	int id;
	FILE *gsf;
	char buf[256];
	snprintf(buf, 255, "%s/.gspinner.roof", getenv("HOME"));
	gsf = fopen(buf, "r");
	if (!gsf)
	{
		lynx_roof(sessionID);
		gsf = fopen(buf, "r");
	}
	if (gsf)
	{
		char name[24] = "\0";
		channels = NULL;
		ids = NULL;
		while (fgets(buf, 255, gsf))
		{
			if (strstr(buf, "</select>")) break;
			name[0] = '\0';
			id = 0;
			sscanf(buf, "\t\t\t\t<option value=\"%d\">%23c</option>"
					"\n" , &id, name);
			if ((id > 0) && name[0])
			{
				char *c;
				int *i = malloc(sizeof(int));
				*i = id;
				c = strrchr(name, '<');
				if (c) *c = '\0';
				c = strdup(name);
				finish(c);
				channels = g_list_append(channels, c);
				ids = g_list_append(ids, i);
			}
		}
	}
}

void get_raasc(char **rurl, char **album, char **artist, char **song, 
		char **channel)
{
	FILE *gsf;
	int ru, al, ar, so, ch;
	char buf[256];
	ru = al = ar = so = ch = 1;
	snprintf(buf, 255, "%s/.gspinner.floor", getenv("HOME"));
	gsf = fopen(buf, "r");
	if (!gsf) return;
	*rurl = malloc(256);
	*album = malloc(128);
	*artist = malloc(128);
	*song = malloc(128);
	*channel = malloc(64);
	memset(*rurl, 0, 256);
	memset(*album, 0, 128);
	memset(*artist, 0, 128);
	memset(*song, 0, 128);
	memset(*channel, 0, 64);
	while ((ru||al||ar||so||ch) && fgets(buf, 255, gsf))
	{
		if (ar)
		{
			sscanf(buf, " shape=\"RECT\" coords=\"10,4,71,1"
					"6\" href=\"http://spinner.com/gateway/artistIn"
					"fo.jhtml?artist=%*s target=\"mainwin\" alt=\""
					"%128c\">\r\n", *artist);
			if (**artist) 
			{
				char *c;
				ar = 0;
				c = strrchr(*artist, '"');
				if (c) *c = '\0';
				finish(*artist);
				continue;
			}
		}
		if (al)
		{
			sscanf(buf, " shape=\"RECT\" coords=\"10,24,71,"
					"36\" href=\"http://www.amazon.com/%*s target="
					"\"external\" alt=\"%128c\">\r\n", *album);
			if (**album) 
			{
				char *c;
				al = 0;
				c = strrchr(*album, '"');
				if (c) *c = '\0';
				finish(*album);
				continue;
			}
		}
		if (so)
		{
			sscanf(buf, " shape=\"RECT\" coords=\"10,44,71,"
					"56\" href=\"javascript:top.Registration_Window"
					"();\" alt=\"%128c\">\r\n", *song);
			if (**song) 
			{
				char *c;
				so = 0;
				c = strrchr(*song, '"');
				if (c) *c = '\0';
				finish(*song);
				continue;
			}
		}
		if (ch)
		{
			sscanf(buf, " shape=\"RECT\" coords=\"10,64,71,"
					"76\" href=\"javascript:top.viewcharts()\" alt="
					"\"%64c\">\r\n", *channel);
			if (**channel) 
			{
				char *c;
				ch = 0;
				c = strrchr(*channel, '"');
				if (c) *c = '\0';
				finish(*channel);
				continue;
			}
		}
		if (ru)
		{
			sscanf(buf, "\t\t\t<embed src=\"/gateway/rpm.jhtml?url_mime_type=rtsp%%3A%%2F%%2Fg2rr.spinner.com%%2Fspinlinks%%2F%256c\" console=\"Spinner\" autostart=\"True\" width=\"20\" height=\"35\" controls=\"VolumeSlider\">\r\n", *rurl);
			if (**rurl) 
			{
				char *c;
				ru = 0;
				c = strstr(*rurl, "%3F");
				if (c) *c = '\0';
				*rurl = realloc(*rurl, strlen(*rurl)+1);
				continue;
			}
		}
	}
	my_system("rm $HOME/.gspinner.floor");
}

void spawn_player(char *rurl)
{
	char buf[512];
	snprintf(buf, 511, "trplayer -n -q rtsp://g2rr.spinner.com/spinlinks/%s"
			, rurl);
	my_system(buf);
}

void menu_activate()
{
	int *i, id;
	GList *l = channels;
	char *data;
	char *ch = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lmenu)->entry));
	while (l)
	{
		data = (char *)l->data;
		if (data)
		{
			if (!strcmp(ch, data))
			{
				id = g_list_position(channels, l);
				break;
			}
		}
		l = l->next;
	}
	i = g_list_nth_data(ids, id);
	if (i) 
	{
		if (channelID == *i) return;
		if (channelID == 0)
		{
			channelID = *i;
			pthread_cond_signal(&cond);
			return;
		}
		channelID = *i;
		kill(trpid, SIGKILL);
	}
}

void spawn()
{
	char *rurl, *album, *artist, *song, *channel;
	char *sessionID;
	int BottomSequence = 0;
	sessionID = get_sessionID();
	get_channels(sessionID);
	gtk_combo_set_popdown_strings(GTK_COMBO(lmenu), channels);
	gtk_signal_connect(GTK_OBJECT(GTK_COMBO(lmenu)->entry), "activate", 
			menu_activate, NULL);
	while (1)
	{
		if (channelID == 0) pthread_cond_wait(&cond, &mutex);
		lynx_floor(sessionID, ++BottomSequence, channelID);
		get_raasc(&rurl, &album, &artist, &song, &channel);
		
		gtk_label_set_text(GTK_LABEL(lartist), artist);
		gtk_label_set_text(GTK_LABEL(lalbum), album);
		gtk_label_set_text(GTK_LABEL(lsong), song);
		gtk_label_set_text(GTK_LABEL(lchannel), channel);

		free(artist);
		free(album);
		free(song);
		free(channel);

		spawn_player(rurl);
		free(rurl);
	}
	free(sessionID);
	pthread_exit(0);
}

void run_atexit()
{
	if (trpid) kill(trpid, SIGKILL);
}

int main(int argc, char *argv[])
{
	pthread_t thread;
	pthread_attr_t attr;
	GtkWidget *window, *table, *mbutton;
	gtk_init(&argc, &argv);
	/* usage */
	if (argc > 1)
	{
		int x;
		for (x = 1; x<argc; x++)
		{
			if (!strcmp(argv[x], "--version"))
			{
				printf("gspinner version 0.1 (%s)\n", 
						versionString);
			}
			if (!strcmp(argv[x], "--help"))
			{
				printf("\nWho is John Galt?\n\n");
			}
		}
		exit(0);
	}
	channelID = 0;
	atexit(run_atexit);
	pthread_attr_init(&attr);
	setenv("REALPLAYER_HOME", REALPLAYER_DIR, 1);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(window), 350, 100);
	gtk_window_set_policy(GTK_WINDOW(window), 0, 0, 0);
	gtk_container_set_border_width(GTK_CONTAINER(window), 5);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event", gtk_main_quit, 
			NULL);

	table = gtk_table_new(5, 2, FALSE);
	gtk_container_add(GTK_CONTAINER(window), table);
	gtk_table_set_row_spacings(GTK_TABLE(table), 0);
	gtk_table_set_col_spacings(GTK_TABLE(table), 5);

	lmenu = gtk_combo_new();
	gtk_combo_disable_activate(GTK_COMBO(lmenu));
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(lmenu)->entry), FALSE);
	gtk_widget_set_usize(GTK_COMBO(lmenu)->entry, 225, 0);
	/* button to change channel */
	mbutton = gtk_button_new_with_label("Select");
	gtk_signal_connect(GTK_OBJECT(mbutton), "clicked", menu_activate, NULL);
	/* make new labels */
	lartist = gtk_label_new("");
	lalbum = gtk_label_new("");
	lsong = gtk_label_new("");
	lchannel = gtk_label_new("");
	/* pack table */
	gtk_table_attach(GTK_TABLE(table), gtk_label_new("Artist:"),
			0, 1, 0, 1, GTK_SHRINK, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), gtk_label_new("Album:"),
			0, 1, 1, 2, GTK_SHRINK, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), gtk_label_new("Song:"),
			0, 1, 2, 3, GTK_SHRINK, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), gtk_label_new("Channel:"),
			0, 1, 3, 4, GTK_SHRINK, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), mbutton, 
			0, 1, 4, 5, GTK_SHRINK, GTK_FILL, 2, 5);
	gtk_table_attach(GTK_TABLE(table), lartist, 
			1, 2, 0, 1, GTK_FILL, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), lalbum, 
			1, 2, 1, 2, GTK_FILL, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), lsong, 
			1, 2, 2, 3, GTK_FILL, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), lchannel, 
			1, 2, 3, 4, GTK_FILL, GTK_SHRINK, 0, 2);
	gtk_table_attach(GTK_TABLE(table), lmenu, 
			1, 2, 4, 5, GTK_FILL, GTK_SHRINK, 2, 5);


	gtk_widget_show_all(window);
	if (pthread_create(&thread, &attr, (void *)&spawn, NULL) < 0)
	{
		perror("pthread_create");
		exit(1);
	}
	gtk_main();
	return 0;
}
